---
// Import components
import StarSelector from "@components/StarSelector.astro";

// Import images
import angleGradientIconImg from "@assets/img/symbols/angle-icon-gradient.svg";
import filterIconImg from "@assets/img/symbols/filter.svg";
import promotedStarIconImg from "@assets/img/symbols/promoted-star.svg";

// Import data
import getDevices from "@logic/build/getDevices.js";

import progressStages from "@data/progressStages.json";
import releases from "@data/releases.json";

// Elaborate data
const unfliteredDevices = await getDevices("get-all-devices");
const devices = unfliteredDevices
  .filter((d) => !d.unlisted)
  .sort((a, b) => b.progress - a.progress);
---

<!-- Sidebar -->
<div class="sidebar d-print-none" transition:persist="search-sidebar">
  <!-- Mobile Toggler -->
  <toggle-button
    data-target="#sidebarCollapse"
    data-action="toggle"
    data-tgclass="show"
    class="sidebar-toggler h6 light d-lg-none"
  >
    <span id="deviceCountMobile">{devices.length} supported devices</span>

    <img
      src={angleGradientIconImg.src}
      class="dark-invert"
      alt="open-devices-list"
    />
  </toggle-button>
  <!-- Collapse -->
  <search-sidebar
    id="sidebarCollapse"
    class="lg-collapse-always-shown collapse"
  >
    <!-- Tab Content -->
    <div id="tabContent" class="tab-content advanced-filters">
      <!-- Search -->
      <input
        id="searchInput"
        class="input search"
        type="text"
        placeholder="Search device"
      />
      <div class="d-flex flex-row align-items-center justify-content-between">
        <h3 class="h6 d-none light d-lg-inline">
          <span id="deviceSearchCount" class="small">
            {devices.length} devices
          </span>
        </h3>

        <toggle-button
          class="btn btn-light btn-small me-3"
          data-target="#advancedFilters"
          data-action="toggle"
          data-tgclass="show"
          data-trackingcategory="Search filters"
          data-trackingname="Filters button"
        >
          <img
            class="sidebar-filter-icon d-inline dark-invert me-2"
            src={filterIconImg.src}
            alt=""
          />
          <span>Filters</span>
        </toggle-button>
      </div>

      <hr />

      <!-- Advanced filters -->
      <div id="advancedFilters" class="advanced-filters-collapse collapse">
        <div class="mt-4">
          <h6 class="small my-3">Show only</h6>

          <label
            ><input name="deviceType" type="checkbox" value="phone" /><span
              class="badge me-1 mb-2 px-3 py-1">Phone</span
            >
          </label>
          <label
            ><input name="deviceType" type="checkbox" value="tablet" /><span
              class="badge me-1 mb-2 px-3 py-1">Tablet</span
            >
          </label>
          <label
            ><input name="deviceType" type="checkbox" value="tv" /><span
              class="badge me-1 mb-2 px-3 py-1">Others</span
            >
          </label>
        </div>

        <div>
          <h6 class="small my-2">Features</h6>

          <label
            ><input name="installerFilter" type="checkbox" checked /><span
              class="badge me-1 mb-2 px-3 py-1">Installer</span
            >
          </label>
          <label
            ><input name="waydroidFilter" type="checkbox" /><span
              class="badge me-1 mb-2 px-3 py-1">Waydroid</span
            >
          </label>
          <label
            ><input name="displayOutFilter" type="checkbox" /><span
              class="badge me-1 mb-2 px-3 py-1">Display out</span
            >
          </label>
        </div>

        <StarSelector
          name="featureStage"
          title="Development Stage"
          starLabels={progressStages.map((s) => s.name)}
          selectedDefault="2"
        />

        <div>
          <h6 class="small my-2 mt-3">Built on</h6>

          {
            ["Halium", "Native", "Legacy"].map((pType) => (
              <label>
                <input name="portType" type="checkbox" value={pType} />
                <span class="badge me-1 mb-2 px-3 py-1">{pType}</span>
              </label>
            ))
          }
        </div>

        <div>
          <h6 class="small my-2">Release</h6>

          {
            releases.list
              .filter((release) => !release.hidden)
              .map((release) => (
                <label>
                  {release.name == releases.default ? (
                    <input
                      name="release"
                      type="radio"
                      value={release.name}
                      checked
                    />
                  ) : (
                    <input name="release" type="radio" value={release.name} />
                  )}
                  <span class="badge me-1 mb-2 px-3 py-1">
                    {release.prettyName}
                    {release.obsolete && "(outdated)"}
                    {release.dev && "(prerelease)"}
                  </span>
                </label>
              ))
          }
        </div>

        <div>
          <h6 class="small my-2">Sort by</h6>

          <label
            ><input name="sortOrder" type="radio" value="name" /><span
              class="badge sort me-1 mb-2 px-3 py-1"
              data-sort="name">ABC</span
            >
          </label>
          <label
            ><input
              name="sortOrder"
              type="radio"
              value="progress"
              checked
            /><span
              class="badge sort me-1 mb-2 px-3 py-1"
              data-sort="progress"
              data-order="desc">Progress</span
            >
          </label>
          <label
            ><input name="sortOrder" type="radio" value="price" /><span
              class="badge sort small me-1 mb-2 px-3 py-1"
              data-sort="price"
              data-order="asc">Price</span
            >
          </label>
        </div>
      </div>

      <!-- All -->
      <div id="all" class="tab-pane fade show active" aria-labelledby="all-tab">
        <ul class="devices-list">
          <!-- Item -->
          {
            devices.map((device) => (
              <li
                class="device-name"
                data-codename={device.codename}
                data-release={device.release}
                data-name={device.name}
                data-progress={device.progress}
                data-price={device.price?.avg}
                data-deviceType={device.deviceType}
                data-portType={
                  device.portType?.startsWith("Halium")
                    ? "Halium"
                    : device.portType
                }
                data-progressStage={device.progressStage.number}
                data-installerAvailable={!device.noInstall ? "1" : ""}
                data-waydroidAvailable={
                  device.portStatus
                    ?.find((el) => el.categoryName == "Misc")
                    ?.features?.find((el) => el.id == "waydroid")?.value == "+"
                    ? "1"
                    : ""
                }
                data-displayOutAvailable={
                  device.isConvergenceEnabled ? "1" : ""
                }
              >
                <a
                  href={device.path}
                  title={device.name + " - Progress: " + device.progress + "%"}
                >
                  <div class="container-fluid">
                    <div>
                      {!!device.tag && (
                        <span
                          class:list={["badge", "device-tag-" + device.tag]}
                        >
                          {device.tag == "promoted" ? (
                            <img
                              class="both-invert"
                              src={promotedStarIconImg.src}
                              alt="promoted"
                            />
                          ) : (
                            device.tag
                          )}
                        </span>
                      )}
                      <span
                        class:list={{
                          "align-text-bottom px-1": device.tag == "promoted"
                        }}
                      >
                        {device.name}
                      </span>
                    </div>
                    <div>
                      <div class="progress progress-sidebar">
                        <div
                          class="progress-bar"
                          role="progressbar"
                          style={"width: " + device.progress + "%"}
                          aria-valuenow={device.progress}
                          aria-valuemin="0"
                          aria-valuemax="1"
                        />
                      </div>
                    </div>
                  </div>
                </a>
              </li>
            ))
          }
        </ul>
      </div>

      <div class="text-center me-3 mt-3">
        <span id="searchNoResults" class="d-none">
          <p class="bold mb-1">This device isn't ported yet.</p>
          <p class="mb-1">Do you own one and want Ubuntu Touch on it?</p>
          <a
            class="link"
            href="https://docs.ubports.com/porting/"
            target="_blank"
            rel="noreferrer noopener">&rarr; Then start your own port.</a
          >
        </span>
        <span id="filteredWarning" class="d-none">
          <p class="bold mb-1">Some devices are hidden by filters.</p>
          <toggle-button
            class="mb-1 btn btn-small btn-outline-primary bold mx-2"
            data-target="#advancedFilters"
            data-action="add"
            data-tgclass="show"
            data-trackingcategory="Search filters"
            data-trackingname="Change filters"
            data-scrollview>Change filters</toggle-button
          >
          <a
            id="disableFilters"
            class="mb-1 btn btn-small btn-light bold mx-2"
            data-trackingname="Disable filters">Disable filters</a
          >
        </span>
      </div>
    </div>
  </search-sidebar>
</div>
